<?
	function ahref($url, $text, $underline=false, $disabled=false, $class="")
	{
		global $linkprefix, $hreftarget, $formvars, $hrefonclickself, $frame;

		if ($class!="")
		{
			$class=" class=\"$class\"";
		}
		if ($disabled)
		{
			return "<span$class>$text</span>";
		}
		$prefix="";
		$suffix="";
		if (isset($formvars) && is_array($formvars) && count($formvars)>0)
		{
			$character="&";
			if (strpos($url, '?')===false)
			{
				$character="?";
			}
			foreach ($formvars as $formvar)
			{
				$suffix.=$character.$formvar["name"]."=".urlparameter($formvar["value"]);
				$character="&";
			}
		}
		if (substr($url, 0, 6) != "mailto")
		{
			$prefix = $linkprefix;
		}
		$target="";
		if (isset($hreftarget))
		{
			$target=" target=\"$hreftarget\"";
		}
		$onclick="";
		if (isset($hrefonclickself) && ($hrefonclickself >=0))
		{
			$target.=" onclick=\"window.self.location='".str_replace("frame=$hrefonclickself", "frame=$frame", $prefix.$url.$suffix)."'\"";
		}
		if (!$underline)
		{
			return "<a href=\"$prefix$url$suffix\"$class$target><span class=notunderlined>$text</span></a>";
		}
		return "<a href=\"$prefix$url$suffix\"$class$target>$text</a>";
	}

	function caching($time=false)
	{
		if ($time==false)
		{
			$time=mktime(0,0,0,1,1,2001);
		}
		Header("Last-Modified: ".gmdate("D, d M Y H:i:s", $time)." GMT");
	}

	function nocaching()
	{
		Header("Expires: Mon, 26 Jul 1997 05:00:00 GMT");
		Header("Last-Modified: ".gmdate("D, d M Y H:i:s")." GMT");
		Header("Cache-Control: no-cache, must-revalidate");
		Header("Pragma: no-cache");
	}

	function hasimages()
	{
		global $preloadthese;
		
		return isset($preloadthese) && count($preloadthese) > 0;
	}
	
	function addpreload($name)
	{
		global $preloadthese;

		if (!isset($preloadthese))
		{
			$preloadthese = array();
		}
		if (!in_array($name, $preloadthese))
		{
			$preloadthese[] = $name;
		}
	}

	function preloadimages()
	{
		global $preloadthese;

		$nopreloads = count($preloadthese);
		if ($nopreloads > 0)
		{
			$preloadimages ="
<script language=\"JavaScript\">
<!--
function preloadimages()
{
    if (document.images)
    {";
			if ($nopreloads == 1)
			{
				$preloadimages.="
        var preload = new Image();
        preload.src = '".$preloadthese[0]."';";
			}
			else
			{
				$preloadimages.= "
        imagearray = new Array('".$preloadthese[0]."'";
				for ($p=1; $p < $nopreloads; $p++)
				{
					$preloadimages.= ", '".$preloadthese[$p]."'";
				}
				$preloadimages.= ");
        for (i=0; i < imagearray.length; i++)
        {
            var preload = new Image();
            preload.src = imagearray[i];
        }";
			}
			$preloadimages.= "
    }
    return true;
}
// -->
</script>";
			return $preloadimages;
		}
		return "";
	}

	function submitbutton($form, $id=0)
	{
/*
		addpreload("submit.gif", $id."0");
		$image0 = $linkprefix."images/submit.gif";
		$image1 = $linkprefix."images/submit2.gif";
		$formstrip = str_replace('_', ' ', $form);
		$inputimage = "<a href=\"javascript:document.$form.submit()\" onMouseOver=\"window.status='submit $formstrip'; return true;\" onMouseOut=\"window.status=''; return true;\">\n";
		$inputimage.= "<img src=\"$image0\" name=\"$id\" border=\"0\" onMouseOver=\"document.$id.src='$image1'; return true;\" onMouseOut=\"document.$id.src='$image0'; return true;\" />\n";
		$inputimage.= "</a>\n";
		return $inputimage;
*/
		return "<input type=submit value=submit />\n";
	}

	function formhiddens()
	{
		global $formvars;
		
		if (isset($formvars))
		{
			$formvar = '';
			foreach ($formvars as $var)
			{
				$formvar .= "<input type=hidden name=".$var['name']." value=\"".$var['value']."\" />\n";
			}
		}
		
		return $formvar;
	}

	function validemail($address)
	{
		return (ereg('^[-!#$%&\'*+\\./0-9=?A-Z^_`a-z{|}~]+'.
					 '@'.
					 '[-!#$%&\'*+\\/0-9=?A-Z^_`a-z{|}~]+\.'.
					 '[-!#$%&\'*+\\./0-9=?A-Z^_`a-z{|}~]+$',
					 $address
					)
			   ); 
	}

	function array_remove(&$thearray, $element)
	{
		$i=count($thearray)-1;
		while (($i >= 0) &&
			   (!($thearray[$i] == $element))
			  ) 	
		{
			$i--;
		}
		if ($i >= 0)
		{
			array_splice($thearray, $i, 1);
		}
	}

	function array_insert(&$thearray, $element, $at)
	{
		$start=array_slice($thearray, 0, $at);
		$start[]=$element;
		$thearray=array_merge($start, array_slice($thearray, $at));
	}

	function urlparameter($urlstring)
	{
		$newstring="";

		$len=strlen($urlstring);
		for ($i=0; $i < $len; $i++)
		{
			$c=$urlstring[$i];
			$ord=ord($c);
			if ( ( ($ord >= ord("0")) && ($ord <= ord("9")) ) ||
				 ( ($ord >= ord("A")) && ($ord <= ord("Z")) ) ||
				 ( ($ord >= ord("a")) && ($ord <= ord("z")) )
			   )
			{
				$newstring.=$c;
			}
			else
			{
				$newstring.=strtoupper("%".base_convert($ord, 10, 16));
			}
		}

		return $newstring;
	}
?>